package no.ntnu.idatt1002.demo.controller;

import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import no.ntnu.idatt1002.demo.data.recipes.FileHandler;
import no.ntnu.idatt1002.demo.data.recipes.Recipe;
import no.ntnu.idatt1002.demo.data.recipes.RecipeRegister;

import java.io.IOException;
import java.net.URL;
import java.util.Optional;
import java.util.ResourceBundle;

public class RecipeTileController implements Initializable {

    @FXML
    private Button nameTag;

    @FXML
    private Label missingTag;

    @FXML
    private VBox recipeTile;

    private RecipeRegister recipeRegister;


    @FXML
    private void tileClick(ActionEvent event) throws IOException {
        FXMLLoader loader = new FXMLLoader();
        loader.setLocation(getClass().getResource("/view/Recipe.fxml"));

        String recipeName = this.nameTag.getText();
        Recipe recipeOfInterest = recipeRegister.getRecipe(recipeName);

        Parent root = loader.load();

        RecipeController recipeController = loader.getController();

        recipeController.setData(recipeOfInterest);

        Stage stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        Scene scene = new Scene(root);
        stage.setScene(scene);
        stage.show();
    }

    public void setData(Recipe recipe) {
        nameTag.setText(recipe.getName());
        missingTag.setText(Integer.toString(recipe.getMissingIngredients()));
    }

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        recipeRegister = FileHandler.readRecipeRegister("Recipes");
        nameTag.setWrapText(true);
    }
}
