package no.ntnu.idatt1002.demo.data.recipes;

import java.util.ArrayList;
import java.util.List;

public class IngredientsAtHand {
//TODO: go through JavaDoc after refactoring.
    //TODO: Make into a set

    private final ArrayList<FoodItem> ingredientsAtHand = new ArrayList<>();

    /**
     * The method returns the collection of ingredients at hand as an arraylist of ingredient objects.
     * @return The collection of ingredients at hand to the user.
     */
    public List<FoodItem> getIngredientsAtHand() {
        return ingredientsAtHand;
    }

    /**
     * The method takes in an ingredient object and adds it to the collection of ingredients at hand.
     * @param ingredient The ingredient object to add to the collection of ingredients at hand.
     */
    public void addIngredient(FoodItem ingredient) {
        if(!this.atHand(ingredient)) {
            this.ingredientsAtHand.add(ingredient);
        }
    }

    //TODO: Unit tests and javadoc
    public boolean atHand(FoodItem foodItem) {
        return ingredientsAtHand.stream().anyMatch( (in) -> in.equals(foodItem));
    }


    /**
     * The method takes in a value of the FoodItem enum as a parameter and removes it from the collection of
     * ingredients at hand if it exists and returns true. If no ingredient of the given type was found in the
     * collection, false is returned.
     * @param ingredientType What type of food the ingredient is.
     * @return True if the ingredient was found among the ingredients at hand and removed, false otherwise.
     */
    public boolean removeIngredient(FoodItem ingredientType) {
        return ingredientsAtHand.remove(ingredientType);
    }


}
